import java.awt.*;
import java.util.*;
import java.applet.*;
import graph.*;

/*
**************************************************************************
**
**                      Applet MHR 2
**
**************************************************************************
**    Copyright (C)
**
**************************************************************************
*
* This applet uses
*
*************************************************************************/

public class arrhenius extends Applet {

      G2Dint graph1        = new G2Dint();   // Graph class to do the plotting
      G2Dint graph2        = new G2Dint();
      Axis xaxis1;
      Axis yaxis1;
      Axis xaxis2;
      Axis yaxis2;
      DataSet data1a;
      DataSet data2a;
      DataSet data1b;
      DataSet data2b;
      int     Change_a  = 1;

      TextField Pinput               = new TextField(5);       // Number of points
      TextField C0input              = new TextField(10);      // Defektenkonzentration
      TextField Tminput              = new TextField(10);      // Temperatur
      TextField HFinput              = new TextField(10);      // HF
      Button plot                    = new Button("Plot It!"); // Button to plot it.





      public void init() {
      	 Label title            = new Label("Concentration of Defects",Label.CENTER);
      	 Panel panel            = new Panel();
         GridBagLayout gridbag  = new GridBagLayout();
         GridBagConstraints  c  = new GridBagConstraints();
         Font font              = new Font("TimesRoman",Font.PLAIN,15);

         title.setFont(new Font("TimesRoman",Font.PLAIN,25));


         setLayout(new BorderLayout() );
         add("North",title);
         add("Center",panel);


         Pinput.setText(getParameter("POINTS"));
         C0input.setText(getParameter("C0"));
         Tminput.setText(getParameter("TM"));
         HFinput.setText(getParameter("HF"));


         panel.setLayout(gridbag);


         Label Plabel           = new Label( "Number of Points" );
         Label C0label          = new Label(" Concentration of defects [cm^-3]");
         Label Tmlabel          = new Label("Temperature [C]");
         Label HFlabel          = new Label("HF [eV]");


         Plabel.setFont(font);
         C0label.setFont(font);
         Tmlabel.setFont(font);
         HFlabel.setFont(font);

         Pinput.setFont(font);
         Pinput.setBackground(Color.lightGray);
         C0input.setFont(font);
         C0input.setBackground(Color.lightGray);
         Tminput.setFont(font);
         Tminput.setBackground(Color.lightGray);
         HFinput.setFont(font);
         HFinput.setBackground(Color.lightGray);

         plot.setFont(font);
         plot.setBackground(Color.green);

//	GRAPH

         c.weightx = 1.0;
         c.weighty = 1.0;
         c.gridwidth = 3;
         c.gridwidth=GridBagConstraints.REMAINDER;
         c.fill  =  GridBagConstraints.BOTH;
         gridbag.setConstraints(graph1,c);
         gridbag.setConstraints(graph2,c);

// 	PLOT

         c.fill  =  GridBagConstraints.NONE;
         c.weightx=0.0;
         c.weighty=0.0;
         c.gridheight=1;
         c.anchor = GridBagConstraints.CENTER;
         gridbag.setConstraints(plot,c);


//	PINPUT
         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(Plabel,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
//         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(Pinput,c);

//    	 Defdekt Konzentration INPUT

         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(C0label,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
//         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(C0input,c);

//	 Temperature INPUT

         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(Tmlabel,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
//         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(Tminput,c);

//       HF Input
         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(HFlabel,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(HFinput,c);


         panel.add(graph1);
         panel.add(graph2);
         panel.add(plot);
         panel.add(Plabel);
         panel.add(Pinput);
         panel.add(C0label);
         panel.add(C0input);
         panel.add(Tmlabel);
         panel.add(Tminput);
         panel.add(HFlabel);
         panel.add(HFinput);

//	Graph Plot 1

         xaxis1 = graph1.createXAxis();
         xaxis1.setTitleText("T  K");
         yaxis1 = graph1.createYAxis();


         data1a = new DataSet();

         xaxis1.attachDataSet(data1a);
         yaxis1.attachDataSet(data1a);
         graph1.attachDataSet(data1a);

         data1b = new DataSet();

         xaxis1.attachDataSet(data1b);
         yaxis1.attachDataSet(data1b);
         graph1.attachDataSet(data1b);


         graph1.setDataBackground(new Color(255,255,255));
         graph1.setBackground(new Color(240,240,240));

//      Graph Plot 2

         xaxis2 = graph2.createXAxis();
         xaxis2.setTitleText("1000/T  K^-1 ");

         yaxis2 = graph2.createYAxis();


         data2a = new DataSet();

         xaxis2.attachDataSet(data2a);
         yaxis2.attachDataSet(data2a);
         graph2.attachDataSet(data2a);

         data2b = new DataSet();

         xaxis2.attachDataSet(data2b);
         yaxis2.attachDataSet(data2b);
         graph2.attachDataSet(data2b);


         graph2.setDataBackground(new Color(255,255,255));
         graph2.setBackground(new Color(240,240,240));


         plot();

      }



      void plot() {
         int 		Points;
         double 	C0;
         double 	Tm;
         double          T;
         double 	HF;
         double 	x1;
         double         xmaximum1;
         double         xminimum1;
         double         ht,ht1,ht2,y1,y2,de1,de2,Cv;
         int 		count = 0;
         boolean 	error = false;
//	Point value

       try {
              Points   = Integer.parseInt(Pinput.getText());
         } catch(Exception e) {
              this.showStatus("Error with number of points!");
              System.out.println("Number of points error "+e.getMessage());
              return;
         }

//	Temperature

       try {
            Tm = Double.valueOf(Tminput.getText()).doubleValue();
         } catch(Exception e) {
              this.showStatus("Error with Temerature value!");
              System.out.println("Temperature error "+e.getMessage());
              return;
         }

         try {
            C0 = Double.valueOf(C0input.getText()).doubleValue();
         } catch(Exception e) {
              this.showStatus("Error with C0 value!");
              System.out.println("C0 error "+e.getMessage());
              return;
         }


//	Z max - min value

       try {
            HF = Double.valueOf(HFinput.getText()).doubleValue();
         } catch(Exception e) {
              this.showStatus("Error HF value!");
              System.out.println("HF error "+e.getMessage());
              return;
         }


         double d1[] = new double[2*Points];
         double d2[] = new double[2*Points];

         this.showStatus("Calculating points!");
                 T =   Tm+273+200;
 	 xminimum1= 100;
	 xmaximum1= T;
         for(int i=0; i<Points; i++) {
             x1= xminimum1 + i*(T-xminimum1)/(Points-1);
 /*            x2= xminimum2 + i*(xmaximum2-xminimum2)/(Points-1);*/
             d1[count] = x1;
             d2[count] = 1000/x1;
             try {

               de1 = HF/(8.625E-5*x1);
               de2 = Math.exp(-de1);
               Cv = C0*de2;
               d1[count+1] =  Cv;
               d2[count+1] = Math.log(Cv)/2.303;
                  count += 2;
             } catch(Exception e) { error = true; }

         }


         if(count <= 2) {
             this.showStatus("Error NO POINTS to PLOT!");
             System.out.println("Error NO POINTS to PLOT!");
             return;
         } else
         if( error ) {
             this.showStatus("Error while Calculating points!");
             System.out.println("Error while calculating points!");
	 }


         yaxis1.setTitleText("Cv");
         yaxis2.setTitleText("log Cv");

         Change_a = (~ Change_a);

         if( Change_a==1) {
                        data1a.deleteData();
                        data2a.deleteData();

                        try {
                             data1a.append(d1,count/2);
                             data1a.linecolor = Color.red;
                             data2a.append(d2,count/2);
                             data2a.linecolor = Color.red;
                            } catch(Exception e) {
                        this.showStatus("Error while appending data!");
                        System.out.println("Error while appending data!");
                        return;
	                }
                        }
                   else {
                        data1b.deleteData();
                        data2b.deleteData();

                        try {
                             data1b.append(d1,count/2);
                             data1b.linecolor = Color.blue;
                             data2b.append(d2,count/2);
                             data2b.linecolor = Color.blue;
                            } catch(Exception e) {
                        this.showStatus("Error while appending data!");
                        System.out.println("Error while appending data!");
                        return;
	                }
                        }

try{
         graph1.repaint();
         graph2.repaint();
           } catch(Exception e) {
                        this.showStatus("Error while drawing data!");
                        System.out.println("Error while drawing data!");
                        return;
	                }
      }



     public boolean action(Event e, Object a) {

         if(e.target instanceof Button) {
             if( plot.equals(e.target) ) {
                  plot();
                  return true;
             }
         }


         return false;
       }




}




