import java.awt.*;
import java.util.*;
import java.applet.*;

import graph.*;
/*
**************************************************************************
**
**                      Applet JC 1
**
**************************************************************************
**    Copyright (C) 
**
**************************************************************************
*
* This applet uses 
*
*************************************************************************/

public class defekt_1 extends Applet {

      G2Dint graph1        = new G2Dint();   // Graph class to do the plotting
      G2Dint graph2        = new G2Dint();
      G2Dint graph3        = new G2Dint();               
      Axis xaxis1;
      Axis yaxis1;
      Axis xaxis2;
      Axis yaxis2;
      Axis xaxis3;
      Axis yaxis3;
      DataSet data1;
      DataSet data2;
      DataSet data3;

      TextField pinput      = new TextField(5);       // Number of points 
      TextField xmininput   = new TextField(10);      // Minimum x value input
      TextField xmaxinput   = new TextField(10);      // Maximum x value input
      TextField tempinput   = new TextField(10);      // Temperatur
      TextField relninput   = new TextField(10);      // N/N'
      TextField hsinput   = new TextField(10);      // Hs
      Button plot           = new Button("Plot It!"); // Button to plot it.





      public void init() {
      	 Label title            = new Label("Cation and Anion Concentration",Label.CENTER);
      	 Panel panel            = new Panel();
         GridBagLayout gridbag  = new GridBagLayout();
         GridBagConstraints  c  = new GridBagConstraints();
         Font font              = new Font("TimesRoman",Font.PLAIN,15);

         title.setFont(new Font("TimesRoman",Font.PLAIN,25));
          
         
         setLayout(new BorderLayout() );
         add("North",title);
         add("Center",panel);

         pinput.setText(getParameter("POINTS")); 
         xmininput.setText(getParameter("XMINIMUM")); 
         xmaxinput.setText(getParameter("XMAXIMUM")); 
         tempinput.setText(getParameter("TEMP")); 
         relninput.setText(getParameter("NdNs")); 
         hsinput.setText(getParameter("Hs")); 


         
         
         panel.setLayout(gridbag);

         Label plabel    = new Label( "Number of Points" );  
         Label xminlabel = new Label("Minimum Hfp/Hs");
         Label xmaxlabel = new Label("Maximum Hfp/Hs");
         Label templabel = new Label("Temperature C");
         Label relnlabel = new Label("N/N'");
         Label hslabel = new Label("Hs [eV]");
 
         
         plabel.setFont(font);
         xminlabel.setFont(font);
         xmaxlabel.setFont(font);
         templabel.setFont(font);
         relnlabel.setFont(font);
         hslabel.setFont(font);

         
         pinput.setFont(font);
         pinput.setBackground(Color.lightGray);
         xmininput.setFont(font);
         xmininput.setBackground(Color.lightGray);
         xmaxinput.setFont(font);
         xmaxinput.setBackground(Color.lightGray);
         tempinput.setFont(font);
         tempinput.setBackground(Color.lightGray);
         relninput.setFont(font);
         relninput.setBackground(Color.lightGray);
         hsinput.setFont(font);
         hsinput.setBackground(Color.lightGray);
         plot.setFont(font);
         plot.setBackground(Color.green);

//	GRAPH

         c.weightx = 1.0;
         c.weighty = 1.0;
         c.gridwidth = 3;
         c.gridwidth=GridBagConstraints.REMAINDER;
         c.fill  =  GridBagConstraints.BOTH;
         gridbag.setConstraints(graph1,c);
         gridbag.setConstraints(graph2,c);
         gridbag.setConstraints(graph3,c);

// 	PLOT

         c.fill  =  GridBagConstraints.NONE;
         c.weightx=0.0;
         c.weighty=0.0;
         c.gridheight=1;
         c.anchor = GridBagConstraints.CENTER;
         gridbag.setConstraints(plot,c);
         
//	PINPUT

         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(plabel,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(pinput,c);

//	X INPUT

         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(xminlabel,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
//         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(xmininput,c);

         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(xmaxlabel,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(xmaxinput,c);

//	Y INPUT

         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(templabel,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
//         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(tempinput,c);

         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(relnlabel,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(relninput,c);

//	Z INPUT

         c.gridwidth=1;
         c.anchor = GridBagConstraints.EAST;
         gridbag.setConstraints(hslabel,c);
         c.gridwidth=2;
         c.anchor = GridBagConstraints.WEST;
//         c.gridwidth=GridBagConstraints.REMAINDER;
         gridbag.setConstraints(hsinput,c);

 
                 
         panel.add(graph1);
         panel.add(graph2);
         panel.add(graph3);
         panel.add(plot);
         panel.add(plabel);
         panel.add(pinput);
         panel.add(xminlabel);
         panel.add(xmininput);
         panel.add(xmaxlabel);
         panel.add(xmaxinput);
         panel.add(templabel);
         panel.add(tempinput);
         panel.add(relnlabel);
         panel.add(relninput);
         panel.add(hslabel);
         panel.add(hsinput);
 

         
//	Graph Plot 1

         xaxis1 = graph1.createXAxis();
         xaxis1.setTitleText("h_{fp}/h_{s}");

         yaxis1 = graph1.createYAxis();


         data1 = new DataSet();

         xaxis1.attachDataSet(data1);
         yaxis1.attachDataSet(data1);
         graph1.attachDataSet(data1);


         graph1.setDataBackground(new Color(255,255,255));
         graph1.setBackground(new Color(240,240,240));

//      Graph Plot 2

         xaxis2 = graph2.createXAxis();
         xaxis2.setTitleText("h_{fp}/h_{s}");
 
         yaxis2 = graph2.createYAxis();
 
 
         data2 = new DataSet();
 
         xaxis2.attachDataSet(data2);
         yaxis2.attachDataSet(data2);
         graph2.attachDataSet(data2);
 
 
         graph2.setDataBackground(new Color(255,255,255));
         graph2.setBackground(new Color(240,240,240));

//      Graph Plot 3

         xaxis3 = graph3.createXAxis();
         xaxis3.setTitleText("h_{fp}/h_{s}");
 
         yaxis3 = graph3.createYAxis();
 
 
         data3 = new DataSet();
 
         xaxis3.attachDataSet(data3);
         yaxis3.attachDataSet(data3);
         graph3.attachDataSet(data3);
 
 
         graph3.setDataBackground(new Color(255,255,255));
         graph3.setBackground(new Color(240,240,240));



         plot();

      }



      void plot() {
         int 		points;
         double 	xmaximum;
         double 	xminimum;
         double 	temp;
         double 	reln;
         double 	hs;
         double 	x;
         double            h1,h2,h3,ht;
         int 		count = 0;
         boolean 	error = false;

//	Point value

         try {
              points   = Integer.parseInt(pinput.getText());
         } catch(Exception e) {
              this.showStatus("Error with number of points!");
              System.out.println("Number of points error "+e.getMessage());
              return;
         }

//	X max - min value

         try {
            xmaximum = Double.valueOf(xmaxinput.getText()).doubleValue();
         } catch(Exception e) {
              this.showStatus("Error with X maximum value!");
              System.out.println("X maximum error "+e.getMessage());
              return;
         }

         try {
            xminimum = Double.valueOf(xmininput.getText()).doubleValue();
         } catch(Exception e) {
              this.showStatus("Error with X minimum value!");
              System.out.println("X minimum error "+e.getMessage());
              return;
         }

 
//	Temperature

         try {
            temp = Double.valueOf(tempinput.getText()).doubleValue();
         } catch(Exception e) {
              this.showStatus("Error with Temerature value!");
              System.out.println("Temperature error "+e.getMessage());
              return;
         }
 
         try {
            reln = Double.valueOf(relninput.getText()).doubleValue();
         } catch(Exception e) {
              this.showStatus("Error with N/N' value!");
              System.out.println("N/N' error "+e.getMessage());
              return;
         }
 

//	Z max - min value
 
         try {
            hs = Double.valueOf(hsinput.getText()).doubleValue();
         } catch(Exception e) {
              this.showStatus("Error h_s value!");
              System.out.println("h_s error "+e.getMessage());
              return;
         }
 

         double d1[] = new double[2*points];
         double d2[] = new double[2*points];
         double d3[] = new double[2*points];

         this.showStatus("Calculating points!");
         ht = 0.025*(273+temp)/293;

         for(int i=0; i<points; i++) {

             x = xminimum + i*(xmaximum-xminimum)/(points-1);
             d1[count] = x;
             d2[count] = x;
             d3[count] = x;
             try {
                  h1 = Math.exp(-hs/(2*ht));
                  h2 = Math.sqrt(1+reln*Math.exp(hs*(1-x)/ht));
                  h3 = Math.exp(-x*hs/ht);
                  d1[count+1] = h1*h2;
                  d2[count+1] = h1/h2;
                  d3[count+1] = reln/h1*h3/h2;
                  count += 2;
             } catch(Exception e) { error = true; }

         }
 

         if(count <= 2) {
             this.showStatus("Error NO POINTS to PLOT!"); 
             System.out.println("Error NO POINTS to PLOT!");
             return;
         } else
         if( error ) {
             this.showStatus("Error while Calculating points!"); 
             System.out.println("Error while calculating points!");
	 }


         yaxis1.setTitleText("c_v (K)");
         yaxis2.setTitleText("c_v (A)");
         yaxis3.setTitleText("c_i (K)");

         data1.deleteData();
         data2.deleteData();
         data3.deleteData();

         try {
               data1.append(d1,count/2);
               data2.append(d2,count/2);
               data3.append(d3,count/2);
         } catch(Exception e) {
             this.showStatus("Error while appending data!"); 
             System.out.println("Error while appending data!");
             return;
	 }
              

         graph1.repaint();
         graph2.repaint();
         graph3.repaint();
      }



     public boolean action(Event e, Object a) {

         if(e.target instanceof Button) {
             if( plot.equals(e.target) ) {
                  plot();
                  return true;
             }
         }


         return false;
       }




}




